import { Abilities, ToAbilityTypes, Normalize, ConditionsMatcher, FieldMatcher } from './types';
import { RawRule } from './RawRule';
declare type Tuple<A extends Abilities> = Normalize<ToAbilityTypes<A>>;
declare type ResolveAction<T> = (action: T | T[]) => T | T[];
export interface RuleOptions<A extends Abilities, Conditions> {
    conditionsMatcher?: ConditionsMatcher<Conditions>;
    fieldMatcher?: FieldMatcher;
    resolveAction?: ResolveAction<Normalize<A>[0]>;
}
export declare class Rule<A extends Abilities, C> {
    private _matchConditions;
    private _matchField;
    private readonly _options;
    readonly action: Tuple<A>[0] | Tuple<A>[0][];
    readonly subject: Tuple<A>[1] | Tuple<A>[1][];
    readonly inverted: boolean;
    readonly conditions: C | undefined;
    readonly fields: string[] | undefined;
    readonly reason: string | undefined;
    readonly priority: number;
    constructor(rule: RawRule<ToAbilityTypes<A>, C>, options: RuleOptions<A, C>, priority?: number);
    private get _lazyMatchConditions();
    private get _lazyMatchField();
    get ast(): import("@ucast/mongo2js").Condition<unknown> | undefined;
    matchesConditions(object: Normalize<A>[1] | undefined): boolean;
    matchesField(field: string | undefined): boolean;
}
export {};
